module dfc.core;

// debugging only
import std.c.stdio;

/*
 * one day I'll tidy this all up :)
 */

// D foundation Classes
//
// This is a core classes to allow potential cross platfrom development
// 
// This will define a minimum interface that any underlying GUI system 
// Must implement in some way.
//
// I intend to also write a New GUI (influenced by the Java Metal Look&Feel) that
// Will implement this minmum with just mouse/keyboard events and nested rectangular drawable areas 
//

import dfc.mswin;
//
// I have used
//  Turbo Vision : GUI lib for Borland C++ (DOS box chars)
//  OWL  : Borlands answer to the MFC (lost the windows C++ lib race)
//  MFC  : Microsofts Foundation classes (C++ Win16 and Win32 lib)
//  WTL  : Windows Template library an MFC influenced template lib for Win32 (much better)
//  GTK  : Unix (ported to Win32) widget tookit for X
//  AWT  : Java's basic windowing libs
//  IFC  : (Netscapes early attempt at a better Java GUI on top of the AWT)
//  JFC/Swing : Sun's own improvements to the AWT (visually good, but cumbersom)
//  Beos : Nice C++ API unlike MFC its not a wrapper, it is the OS's API.
//  PalmOS : PDA gui OS (basic C event handleing API)
//  VCL  : Borlands Delphi Gui libs
//  Looked at WxWindows and vGui
//  probed swt (IBM's (eclipse) replacement for the AWT)
//  and started to look at raw X under linux (for all of a week!)
//


//! the basic stuff that all 'windows' must support
//
//class BaseGUItem {
//}

class DFrame : DWnd
{
public:
	this() 
	{ 
		super();
	}

	void setClientSize( int width, int height )
	{
		RECT cr;
		RECT wr;
		SIZE sz;
		if (getHwnd() === null) { return; }
		
		sz.cx = width; 
		sz.cy = height;
		setSize( sz );
		
		getClientRect( cr );
		getWindowRect( wr );
		
		sz.cx = (wr.right - wr.left) + (width - (cr.right - cr.left));
		sz.cy = (wr.bottom - wr.top) + (height - (cr.bottom - cr.top));
		setSize( sz );
	}

	void centerWindow()
	{
		RECT sr;
		RECT wr;
		int x, y, w, h;

		GetWindowRect( GetDesktopWindow(), &sr );
		getWindowRect( wr );
		w = wr.right - wr.left;
		h = wr.bottom - wr.top;
		x = ((sr.right - sr.left - w)>>1);
		y = ((sr.bottom - sr.top - h)>>1);
		MoveWindow( getHwnd(), x, y, w, h, true );
	}
}

class DApp : DFrame
{
public:
	this() 
	{ 
		super();
		addNativeHandler( WM_DESTROY, &this.exitFunc );
	}
	
	LRESULT exitFunc( WPARAM wparam,LPARAM lparam )
	{
		PostQuitMessage( 0 );
		return cast(LRESULT)0;
	}
}

class DSubClassedWnd : DWnd
{
protected:
	WNDPROC subClassWindProc;
public:
	this( char[] classname ) { super( classname ); } 

	void postCreateWindow()
	{
		subClassWindProc = DFC.subclass( hwnd );
	}

	LRESULT unhandledMsg( HWND msghwnd, UINT msg, WPARAM wparam, LPARAM lparam )
	{
		return CallWindowProcA( subClassWindProc, msghwnd, msg, wparam, lparam );
	}
}

class DComponant : DWnd
{
	this() 
	{ 
		super(); 
		addMouseDownHandler( WM_LBUTTONDOWN, &this.onMouseDown );
		addMouseDownHandler( WM_RBUTTONDOWN, &this.onMouseDown );
		addMouseDownHandler( WM_MBUTTONDOWN, &this.onMouseDown );
		addMouseUpHandler( WM_LBUTTONUP, &this.onMouseUp );
		addMouseUpHandler( WM_RBUTTONUP, &this.onMouseUp );
		addMouseUpHandler( WM_MBUTTONUP, &this.onMouseUp );
	}

protected:
	LRESULT onMouseDown( int x, int y, int keys )
	{
		int i;
		i = cast(int)hwnd;
		printf( "mouseDown -- 0x%X\n", i );
		return cast(LRESULT)0;
	}
	LRESULT onMouseUp( int x, int y, int keys )
	{
		int i;
		i = cast(int)hwnd;
		printf( "mouseUp   -- 0x%X\n", i );
		return cast(LRESULT)0;
	}
}

