module dfc.dstatic;

import std.c.stdio;

import dfc.core;

// D foundation Classes
//
// Win32 Statics ...
//

/*
 * WM_COMMAND possible button commands
 *
 // only get these if SS_NOTIFY is set in the window style
STN_CLICKED
STN_DBLCLK
STN_DISABLE
STN_ENABLE

// ----------------------------------
 * Static Control Constants
SS_LEFT             =0x00000000,
SS_CENTER           =0x00000001,
SS_RIGHT            =0x00000002,
SS_ICON             =0x00000003,
SS_BLACKRECT        =0x00000004,
SS_GRAYRECT         =0x00000005,
SS_WHITERECT        =0x00000006,
SS_BLACKFRAME       =0x00000007,
SS_GRAYFRAME        =0x00000008,
SS_WHITEFRAME       =0x00000009,
SS_USERITEM         =0x0000000A,
SS_SIMPLE           =0x0000000B,
SS_LEFTNOWORDWRAP   =0x0000000C,
SS_OWNERDRAW        =0x0000000D,
SS_BITMAP           =0x0000000E,
SS_ENHMETAFILE      =0x0000000F,
SS_ETCHEDHORZ       =0x00000010,
SS_ETCHEDVERT       =0x00000011,
SS_ETCHEDFRAME      =0x00000012,
SS_TYPEMASK         =0x0000001F,
SS_NOPREFIX         =0x00000080, // Don't do "&" character translation 
SS_NOTIFY           =0x00000100,
SS_CENTERIMAGE      =0x00000200,
SS_RIGHTJUST        =0x00000400,
SS_REALSIZEIMAGE    =0x00000800,
SS_SUNKEN           =0x00001000,
SS_ENDELLIPSIS      =0x00004000,
SS_PATHELLIPSIS     =0x00008000,
SS_WORDELLIPSIS     =0x0000C000,
SS_ELLIPSISMASK     =0x0000C000

*
*/

class DStatic : DSubClassedWnd
{
	static const char[] NATIVE_CLASS_NAME = "STATIC";

	this()
	{
		super( NATIVE_CLASS_NAME );
	}

/*
IMAGE_BITMAP
IMAGE_CURSOR
IMAGE_ENHMETAFILE
IMAGE_ICON
*/
	HANDLE getImage( int imageType )
	{
		return cast(HANDLE)sendMsg( STM_GETIMAGE, imageType, 0 );
	}

	void setImage( HANDLE image, int imageType )
	{
		sendMsg( STM_SETIMAGE, imageType, cast(LPARAM)image );
	}

	HICON getIcon()
	{
		return cast(HICON)sendMsg( STM_GETICON, 0, 0 );
	}

	void setIcon( HICON image )
	{
		sendMsg( STM_SETICON, cast(WPARAM)image, 0 );
	}

	void setState( int state )
	{
		sendMsg( BM_SETSTATE, cast(WPARAM)state, 0 );
	}

	void setStyle( uint style, bit redraw )
	{
		sendMsg( BM_SETSTYLE, style, redraw ? 1 : 0 );
	}
}


